"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineFlowType = _interopRequireDefault(require("./rules/defineFlowType"));
var _genericSpacing = _interopRequireDefault(require("./rules/genericSpacing"));
var _noWeakTypes = _interopRequireDefault(require("./rules/noWeakTypes"));
var _requireParameterType = _interopRequireDefault(require("./rules/requireParameterType"));
var _requireReturnType = _interopRequireDefault(require("./rules/requireReturnType"));
var _requireValidFileAnnotation = _interopRequireDefault(require("./rules/requireValidFileAnnotation"));
var _semi = _interopRequireDefault(require("./rules/semi"));
var _spaceAfterTypeColon = _interopRequireDefault(require("./rules/spaceAfterTypeColon"));
var _spaceBeforeGenericBracket = _interopRequireDefault(require("./rules/spaceBeforeGenericBracket"));
var _spaceBeforeTypeColon = _interopRequireDefault(require("./rules/spaceBeforeTypeColon"));
var _unionIntersectionSpacing = _interopRequireDefault(require("./rules/unionIntersectionSpacing"));
var _typeIdMatch = _interopRequireDefault(require("./rules/typeIdMatch"));
var _useFlowType = _interopRequireDefault(require("./rules/useFlowType"));
var _validSyntax = _interopRequireDefault(require("./rules/validSyntax"));
var _booleanStyle = _interopRequireDefault(require("./rules/booleanStyle"));
var _delimiterDangle = _interopRequireDefault(require("./rules/delimiterDangle"));
var _noDupeKeys = _interopRequireDefault(require("./rules/noDupeKeys"));
var _sortKeys = _interopRequireDefault(require("./rules/sortKeys"));
var _objectTypeDelimiter = _interopRequireDefault(require("./rules/objectTypeDelimiter"));
var _recommended = _interopRequireDefault(require("./configs/recommended.json"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var _default = {
  configs: {
    recommended: _recommended["default"]
  },
  rules: {
    'boolean-style': _booleanStyle["default"],
    'define-flow-type': _defineFlowType["default"],
    'delimiter-dangle': _delimiterDangle["default"],
    'generic-spacing': _genericSpacing["default"],
    'no-dupe-keys': _noDupeKeys["default"],
    'no-weak-types': _noWeakTypes["default"],
    'object-type-delimiter': _objectTypeDelimiter["default"],
    'require-parameter-type': _requireParameterType["default"],
    'require-return-type': _requireReturnType["default"],
    'require-valid-file-annotation': _requireValidFileAnnotation["default"],
    semi: _semi["default"],
    'sort-keys': _sortKeys["default"],
    'space-after-type-colon': _spaceAfterTypeColon["default"],
    'space-before-generic-bracket': _spaceBeforeGenericBracket["default"],
    'space-before-type-colon': _spaceBeforeTypeColon["default"],
    'type-id-match': _typeIdMatch["default"],
    'union-intersection-spacing': _unionIntersectionSpacing["default"],
    'use-flow-type': _useFlowType["default"],
    'valid-syntax': _validSyntax["default"]
  },
  rulesConfig: {
    'boolean-style': 0,
    'define-flow-type': 0,
    'delimiter-dangle': 0,
    'generic-spacing': 0,
    'no-dupe-keys': 0,
    'no-weak-types': 0,
    'object-type-delimiter': 0,
    'require-parameter-type': 0,
    'require-return-type': 0,
    semi: 0,
    'sort-keys': 0,
    'space-after-type-colon': 0,
    'space-before-generic-bracket': 0,
    'space-before-type-colon': 0,
    'type-id-match': 0,
    'union-intersection-spacing': 0,
    'use-flow-type': 0,
    'valid-syntax': 0
  }
};
exports["default"] = _default;